function [f, grad_f] = GMMMPEC_f(x0)

% GMMMPEC_f
% GMM Objective function for the random coefficients Logit esitmated via
% MPEC.
%
% source: Dube, Fox and Su (2012)
% Code Revised: January 2012
% Code Modified by P. Ketz: December 2015  


global W K K_rc numProdsTotal

g = x0(K+K_rc+numProdsTotal+1:end,1);                 % moment condition values

f = g'*W*g; 

if nargout==2,
    nx0 = size(x0,1);
    grad_f = zeros(nx0,1);
    grad_f(K+K_rc+numProdsTotal+1:end,1) = 2*W*g;
end