function delta = invertshares(sigma2,expmeanval,num_rep)

% INVERTSHARES
% GMM objective function for the random coefficients Logit estimated via
% the NFP approach proposed by BLP.
%
% source: Dube, Fox and Su (2010)
% Code Revised: March 2009
% Code Modified by P. Ketz: December 2015  


global x_rc tol_inner share points

sigma = sqrt(sigma2);

ii = 0;
norm_max = 1;
expmeanval0 = expmeanval;

expmu = exp(x_rc*diag(sigma)*points);      % exponentiated deviations from mean utilities

while norm_max > tol_inner && ii < num_rep
    expmeanval1 = expmeanval0.*share./ind_shnorm(expmeanval0,expmu); 
    t = abs(expmeanval1-expmeanval0);
    norm_max = max(t);
    expmeanval0 = expmeanval1;
    ii = ii + 1;
end

if max(isnan(expmeanval0))<1 
    expmeanval = expmeanval0; 
else 
    disp('oops!');
end

delta = log(expmeanval);         
