function [share,nopurch] = mksharesg(betatrue,xi,rc)

%%%%%%%%%%%%
% MKSHARESG (previously: MKSHARESIM)
% generates market share data.
%
% source: Dube, Fox and Su (2012)
% Code Revised: January 2012
% Code Modified by P. Ketz: December 2015  


global x x_rc sharesum marketForProducts numProdsTotal weights T

delta = x*betatrue+xi;

MU = x_rc*rc;
numer = exp( repmat(delta,1,size(rc,2)) + MU );  % exp of utility for each simulated consumer

sum1 = sharesum*numer;                  % sum of utility for each consumer
sum11 = 1./(1+sum1);                    % this is the denominator of the shares
denom1 = sum11(marketForProducts,:);    % this expands the denominator
sum11 = sum11.*(ones(T,1)*weights);
shareForDraws = numer.*denom1;          % simulated shares for each draw
shareForDraws = shareForDraws.*(ones(numProdsTotal,1)*weights);
share = sum(shareForDraws,2);          % expected share (i.e. mean across draws)
nopurch = sum(sum11,2);                % Fraction in each market not purchasing


